<?php

namespace Drupal\frontend_publishing\Plugin\frontend_publishing;

use Drupal\Component\Plugin\PluginInspectionInterface;
use Drupal\Core\Entity\ContentEntityBase;
use Drupal\Core\Plugin\ContainerFactoryPluginInterface;

interface StateChangePluginInterface extends PluginInspectionInterface, ContainerFactoryPluginInterface
{

    public function publish(ContentEntityBase &$entity);

    public function unpublish(ContentEntityBase &$entity);

    public function copy(ContentEntityBase &$entity, ContentEntityBase &$clone = null);

    public function generate(ContentEntityBase &$entity);

    public function delete(ContentEntityBase &$entity);

    public function transition(ContentEntityBase &$entity);

    public function hasChanges(ContentEntityBase &$entity);
}
